// fulldome.pov
// Convert source video to a fulldome with background sky.
// Miroslav Broz (miroslav.broz@email.cz), Mar 23rd 2018

#version 3.7;

#include "common.pov"
#include "interp.pov"

#declare nhours = 24;
#declare km = 1.e0;

#include "aunits.pov"

#declare nts = 2;
#declare ts = array[nts]
#declare ts[0] =   0;
#declare ts[1] =   2;

#declare fps = 25;

#include "times.pov"

/**********************************************************************/

// source video

#macro pad(a, n)
  #local i = 0;
  #local s = "";
  #local tmp = str(a, n, 0)
  #while (i < strlen(tmp)+1)
     #local c = substr(tmp,i,1);
     #if (strcmp(c, " ") = 0)
       #local s = concat(s, "0");
     #else
       #local s = concat(s, c);
     #end
     #local i = i+1;
  #end
  s
#end


#declare frm = pad(int(clock * (ts[nts-1] * fps - 1) + 1 + 0.5), 2);
#debug concat("frame_number = ", frm, "\n")

#declare b = 90;

mesh {
  triangle { <0,0,0>, <1,0,0>, <1,1,0> }
  triangle { <0,0,0>, <0,1,0>, <1,1,0> }
  texture {
    pigment {
      image_map {
        png concat("../100let.pdf", frm, ".png")
        gamma 2.2
//        gamma 1.0  // dbg
        map_type 0
        interpolate 2
      }
    }
    finish {
      ambient 1.0
      diffuse 0
    }
  }
  translate <-0.5,-0.5,0>
  rotate 12.5*x
  scale <3307/1860, 1, 1>
  scale <1.1, 1, 1>
  translate <0,0,1>
  translate <0,-0.175,0>
}

/**********************************************************************/

#declare v_cam = <0,0,0>;

#declare v_lat = v_cam + <0,1,0>;
#declare v_lat = vaxis_rotate(v_lat,x,40);

/**********************************************************************/

camera {
  fisheye
  location v_cam
  look_at v_lat
  right v_right
  angle a_cam
}


